#include <signal.h>     /*                   */
#include <ctype.h>      /*         */
#include <dirent.h>     /*    BSD 4.2 */
#include <pwd.h>        /*   /etc/passwd              */
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>


#include <string.h>

#include "cmdline.h"
#include "tok.h"
#include "exec.h"

void sigCHILD(int s)
{
  sigset_t cldset;
  sigprocmask(SIG_UNBLOCK,&cldset,0);  
  waitpid(-1,NULL,WNOHANG);
}

static char gdir[516];

void sigALARM(int is)
{
struct stat b;
char* s;
int hour,min,sec;
  strcpy(gdir,"/var/spool/mail");
  
  s = (char*)getenv("HOME");
  s = (char*)strrchr(s,'/');

  strcat(gdir,s);
  
  if( !stat(gdir,&b) )
    if( b.st_size ) memcpy(gdir,buf+x,slen), gdir[slen+1]='\0',
	fprintf(stderr,"\nkssh:    email\n@  %s",gdir);

  s = findvar("ckmail");
  if( sscanf(s,"%i:%i:%i",&hour,&min,&sec)==3 ) alarm(hour*3600+min*60+sec);
   else if( sscanf(s,"%i",&sec) ) alarm(sec);
}

void setcwd() /*     */
{
 char cwd[512]; getcwd(cwd,512); setenv( "CWD", cwd );
}

main()
{
 char *user = "root";      /*       */
 char *home = "/root";     /*    */
 int uid = getuid(); //  uid
 struct passwd *p = getpwuid(uid); // -    uid
 register i; // ޣ   
 
 if( p != NULL )
 {
    if(p->pw_name && *p->pw_name ) user = p->pw_name;
    if(               *p->pw_dir ) home = p->pw_dir;
 }
 setenv("USER", user); setenv("HOME", home);
 setvar("home", home); setvar("path", ".:/bin:/sbin:/usr/bin:/usr/sbin");
 setvar("status","0");
 setvar("ckmail","00:00:10");
 alarm(10);
 
 //   .
 {
 sigset_t cldset; // 

    sigemptyset(&cldset); //  SIGTTOU
    sigaddset(&cldset,SIGTTOU); // 
    sigprocmask(SIG_BLOCK,&cldset,0); // 
    
    signal(SIGINT,SIG_IGN);
    signal(SIGCHLD,sigCHILD);
    signal(SIGALRM,sigALARM);
 }
 
 for(i=0; i<MAXARGS; i++) args[i]=NULL;
 
 for(;;)
 {
  char *s; //    

  s = getcmd(); //   
  
  tok(s); // ߣ   
  
  if(argn==0) continue;

  if(strcmp(args[0],"logout")==0) exit(0);
  if(strcmp(args[0],"exit")==0) puts("kssh:  kssh ۣ"), exit(0);
  if(strcmp(args[0],"pwd")==0)
  {
    printf("%s\n",getcwd(gdir,516)); 
   continue;
  }
  if(strcmp(args[0], "cd" )==0)
  {
   char *d = (argn==1) ? (char*)getenv("HOME"):args[1];
   if(chdir(d) < 0) fprintf(stderr,"kssh:     `%s`\n", d ); else setcwd();
   continue;
  }
  if(strcmp(args[0], "cd.." )==0) { chdir(".."); setcwd(); continue;}
  if(strcmp(args[0], "echo" )==0) 
  {
   for(i=1; i<argn; i++)  printf("%s%c",args[i],argn==i+1 ? '\n':' ');
   continue;
  } 
  if(strcmp(args[0], "unset" )==0) 
  {
   if(args[1]) unsetvar(args[1]);
   continue;
  }  
  if(s=(char*)strchr(args[0],'='))
  {
   *s++='\0';
   if(strcmp(args[0],"ckmail")==0)
   {
   int hour,min,sec;
    if( sscanf(s,"%i:%i:%i",&hour,&min,&sec)==3 ) alarm(hour*3600+min*60+sec);
    else if( sscanf(s,"%i",&sec) ) alarm(sec);
    else{ fprintf(stderr,"kssh:    .,  hour:min:sec\n"); continue;}
   }    
   setvar( args[0], s? s:""); //   
   continue;
  }
  if(strcmp(args[0],"export")==0)
  { /*  /  */
   if(argn>1) for(i=1; args[i]; i++)
	setenv(args[i],(char*)strdup(findvar(args[i])));
   else for(i=0; environ[i]; i++) printf("%s\n",environ[i]);
   continue;
  }
  
   cmdExec(args[0],args,environ); //   
 }
}
